// exception when opening a file etc.

#include "fileexception.hh"

namespace concepts {

  // ********************************************************* FileOpenError **

  FileOpenError::FileOpenError(const std::string& file) throw() :
    MissingFeature(file) {}

  std::ostream& FileOpenError::info(std::ostream& os) const throw() {
    return os << '[' << file_ << ", line " << line_ << "] " << function_ 
	      << " -- error on opening file '" << feature_ << "'";
  }

}
