// exception when a fortran routine returns a info != 0 flag

#ifndef fortranException_hh
#define fortranException_hh

#include "exceptions.hh"

namespace concepts {

  // ****************************************************** FortranException **

  /** Exception indicating an error in a FORTRAN routine returning a
      non-zero \c info flag.
      @author Philipp Frauenfelder, 2002
   */
  class FortranException : public MissingFeature {
  public:
    /** Constructor.
	@param info \c info flag of the FORTRAN routine
	@param name Name of the FORTRAN routine
    */
    FortranException(const int info, const std::string& name) throw();
  protected:
    virtual std::ostream& info(std::ostream& os) const throw();
  };

} // namespace concepts

#endif // fortranException_hh
