// fabric for JdbSym eigensolver

#include "jdbsymFabric.hh"
#include "operator/compositions.hh"

// debugging
#include "basics/debug.hh"

#define JdbSymFabricDestr_D 0

namespace eigensolver {

  // ********************************************************** JdbSymFabric **

  JdbSymFabric::~JdbSymFabric() {
    DEBUGL(JdbSymFabricDestr_D, "done.");
  }

  JdbSym& JdbSymFabric::operator()(concepts::Operator<Real>& stiff,
				   concepts::Operator<Real>& mass) {
    solver_.reset(new JdbSym(stiff, mass, tol_, maxit_, tau_, jdtype_,
			     kmax_, fabric_, start_));
    return *solver_;
  }

  std::ostream& JdbSymFabric::info(std::ostream& os) const {
    if (solver_.get())
      return os << *solver_;
    else
      return os << solver_.get();
  }

} // namespace eigensolver
