/** @file geometry/testsuite/meshConverter.hh
    Test suite for mesh converter
*/

#ifndef meshConverter2Dtest_hh
#define meshConverter2Dtest_hh

#include "basics/testcase.hh"

namespace test {

  // ****************************************************** ConvertMeshQuads **

  /** Tests conversion of triangular into quadrilateral meshes
      @author Philipp Frauenfelder, 2004
      @see concepts::ConvertMeshQuads
  */
  class ConvertMeshQuads : public TestCase {
  public:
    virtual ~ConvertMeshQuads() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests with an empty mesh
    void testEmpty();
    /// Tests with a quad only mesh
    void testQuadMesh();
    /// Tests with a triangle only mesh
    void testTriangleMesh();
    /// Tests with a mixed mesh (triangles and quads)
    void testMixedMesh();
    //@}
  };
  
} // namespace test

#endif // meshConverter2Dtest_hh
