/* testsuite for 3D cells
 */

#include <memory>
#include "basics/exceptions.hh"
#include "geometry.hh"

int main(int, char**) {

  using namespace concepts;

  Stacktrace::doit() = false;
  try {
    Import3dMesh mesh(SOURCEDIR "/geometry/testsuite/ClassCoord3D.dat",
		      SOURCEDIR "/geometry/testsuite/Tetrahedra.dat",
		      SOURCEDIR "/geometry/testsuite/empty.dat");
    std::cout << mesh << std::endl;
    std::auto_ptr<Scan3> sc(mesh.scan());
    while (*sc) {
      Cell3& cell = (*sc)++;
      std::cout << "  has cell " << cell << std::endl;
    }
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
    return 1;
  }
  
  return 0;
}
