/* testsuite for subdivision strategies of Quad
 */

#include <iostream>
#include <memory>
#include "geometry/topology.hh"

using namespace concepts;

int main(int, char**) {
  concepts::Stacktrace::doit() = false;
  try {
    Vertex v1(1);
    Vertex v2(2);
    Edge e1(v1, v2);
    Vertex v3(3);
    Edge e2(v2, v3);
    Vertex v4;
    Edge e4(v3, v4);
    Edge e5(v4, v1);
    Quad q1(e1, e2, e4, e5);
    std::cout << q1 << std::endl;
    for (uint j = 0; j < 4; ++j)
      std::cout << "  child " << j << ": " << q1.child(j,1) << std::endl;
    q1.setStrategy(QuadSubdiv2V::instance());
    Quad* child = 0;
    for (uint j = 0; (child = q1.child(j)) != 0; ++j)
      std::cout << "  child " << j << ": " << *child << std::endl;
    std::cout << "Triggering 'illegal change of strategy':" << std::endl;
    q1.setStrategy(QuadSubdiv4::instance());
  }
  catch(concepts::ExceptionBase& e) {
    std::cout << e << std::endl;
  }

  return 0;
}
