/* testsuite for 2D cells
 */

#include "basics/exceptions.hh"
#include "geometry.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    Vertex v1(1);
    Vertex v2(2);
    Edge e1(v1, v2);
    Vertex v3(3);
    Edge e2(v2, v3);
    Vertex v4;
    Edge e4(v3, v4);
    Edge e5(v4, v1);
    Quad q1(e1, e2, e4, e5);
    std::cout << q1 << std::endl;
    MapQuad2d m("(x,y)", 1.0, 1.0);
    Quad2d q2(q1, m);

    std::cout << "Quad cell = " << q2 << std::endl;
    std::cout << "chi(0.5, 0.5) = " << q2.chi(0.5, 0.5) << std::endl;

    Quad2d* child = 0;
    q2.setStrategy(Quad2dSubdiv2V::instance());
    for (uint i = 0; (child = q2.child(i)) != 0; ++i)
      std::cout << "child(" << i << ") = " << *child << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
    return 1;
  }

  return 0;
}
