#include "uniformlyRefinedMesh2.hh"

namespace concepts {

  UniformlyRefinedMesh2::UniformlyRefinedMesh2(concepts::Mesh2& coarseMesh,
                                               uint level) {
    std::auto_ptr<concepts::Scan2> sc(coarseMesh.scan());
    while (*sc) {
      concepts::Cell2& cell = (*sc)++;
      addCell(&cell, level);
    }
  }

  void UniformlyRefinedMesh2::addCell(concepts::Cell2* cell, uint level) {
    if(level == 0) {
      // add cell
      cell_.push_back(cell);
    } else {
      // add children
      uint i=0;
      while(concepts::Cell2* child = cell->child(i++)) {
        addCell(child, level-1);
      }
    }
  }

} // namespace concepts
