/* graphics of the mesh in Gnuplot
 */

#include <fstream>
#include "basics/exceptions.hh"
#include "basics/vectorsMatrices.hh"
#include "space/element.hh"
#include "geometry/cell.hh"
#include "toolbox/elementGraphics.hh"
#include "meshGnuplot.hh"

namespace graphics {

  // ******************************************************* MeshGnuplotCell **

  template<typename F>
  MeshGnuplotCell<F>::~MeshGnuplotCell() {
  }

  template<typename F>
  void MeshGnuplotCell<F>::operator() (const concepts::Element<F>& elm)
    throw(concepts::MissingFeature) {
    elm.graphics()->operator()(elm,
			       concepts::ElementGraphics<F>::MESH_GNUPLOT,
			       *this);
  }

  template<typename F>
  void MeshGnuplotCell<F>::operator() (const concepts::Cell& cell)
    throw(concepts::MissingFeature) {

    const concepts::Cell1* c1 = dynamic_cast<const concepts::Cell1* >(&cell);
    if (c1) {
      for (uint i = 0; i < 1; ++i)
	*ofs_ << c1->vertex(i)[0] << ' ' << 0 << std::endl;
      *ofs_ << std::endl;
      return;
    }

    throw conceptsException(concepts::MissingFeature("cell not supported"));
  }

  template class MeshGnuplotCell<Real>;

} // namespace graphics
