// include files for the hp2D subdirectory

#ifndef hp2D_hh
#define hp2D_hh

#include "hp2D/element.hh"
#include "hp2D/quad.hh"
#include "hp2D/space.hh"
#include "hp2D/bilinearForm.hh"
#include "hp2D/linearForm.hh"
#include "hp2D/rotrot.hh"
#include "hp2D/divdiv.hh"
#include "hp2D/shortestDist.hh"
#include "hp2D/singularSet.hh"
#include "hp2D/formulaFromWeight.hh"
#include "hp2D/transmissionWeight.hh"
#include "hp2D/aprioriRef2D.hh"
#include "hp2D/function.hh"
#include "hp2D/buildDofsBase.hh"
#include "hp2D/buildVtxDofs.hh"
#include "hp2D/buildEdgeDofs.hh"
#include "hp2D/buildInnerDofs.hh"

/** 2D hp-FEM for H<sup>1</sup>-conforming elements.

    The Space can be built using full tensor product polynomial spaces in
    the elements or trunk spaces (and much more) by changing the way the
    degrees of freedom are built in the BuildDofsBase class (and its
    specializations).

    @author Philipp Frauenfelder, 2001
*/
namespace hp2D {
  // leave this empty, just for documentation
}

#endif // hp2D_hh
