/* Graphics for 2D hp FEM
 */

#ifndef quadGraphics_hh
#define quadGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace hp2D {
  using concepts::Real;

  // ********************************************************** QuadGraphics **

  /** Handles graphics for 2D hp FEM elements.
      @author Philipp Frauenfelder, 2002
  */
  class QuadGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace hp2D

#endif // quadGraphics_hh
