/** @file cloneing.hh Test for clone function in hp2D::RotRot and hp2D::DivDiv
 */

#ifndef cloneing_hh
#define cloneing_hh

#include "basics/testsuite.hh"
#include "basics/typedefs.hh"

namespace vectorial {
  // forward declaration
  template<typename F>
  class BilinearForm;
}

namespace test {

  // ************************************************************** Cloneing **

  /** Test cloneing of vector valued blinear forms. The test routine
      tests if the clone of a vectorial::BilinearForm really is a deep copy
      (ie. also the shared data is copied). This is done for hp2D::RotRot
      and hp2D::DivDiv.
      @author Philipp Frauenfelder, 2004
  */
  class Cloneing : public TestCase {
  public:
    virtual ~Cloneing();
    virtual void run();

    /// @name Test routines
    //@{
    template<typename max>
    void testMaxwell(vectorial::BilinearForm<concepts::Real>& bf);
    //@}
  };

} // namespace test

#endif // cloneing_hh
