// include files for the hp3D subdirectory

#ifndef hp3D_hh
#define hp3D_hh

#include "hp3D/element.hh"
#include "hp3D/hexahedron.hh"
#include "hp3D/space.hh"
#include "hp3D/linearForm.hh"
#include "hp3D/bilinearForm.hh"
#include "hp3D/hpExtension.hh"
#include "hp3D/zerotangential.hh"
#include "hp3D/rotrot.hh"
#include "hp3D/divdiv.hh"
#include "hp3D/singularSet.hh"
#include "hp3D/shortestDist.hh"
#include "hp3D/spaceTransition.hh"
#include "hp3D/formulaFromWeight.hh"
#include "hp3D/sumfact.hh"
#include "hp3D/aprioriRef.hh"
#include "hp3D/buildDofsBase.hh"
#include "hp3D/buildVtxDofs.hh"
#include "hp3D/buildEdgeDofs.hh"
#include "hp3D/buildFaceDofs.hh"
#include "hp3D/buildInnerDofs.hh"

/** 3D hp-FEM for H<sup>1</sup>-conforming elements.

    The Space can be built using full tensor product polynomial spaces in
    the elements or trunk spaces (and much more) by changing the way the
    degrees of freedom are built in the BuildDofsBase class (and its
    specializations).

    @author Philipp Frauenfelder, 2001
    @todo Three dimensional <span class="math">hp</span>-DGFEM in hexahedra
    for locally refined meshes.
*/
namespace hp3D {
  // leave this empty, just for documentation
}

#endif // hp3D_hh
