/* Graphics for hexahedra
 */

#ifndef hexGraphics_hh
#define hexGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace hp3D {

  using concepts::Real;

  // **************************************************** HexahedronGraphics **

  /** Handles graphics for hexahedral 3D hp FEM elements.
      @author Philipp Frauenfelder, 2002
  */
  class HexahedronGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace hp3D

#endif // hexGraphics_hh
