// testing integration

#ifndef testIntegration_hh
#define testIntegration_hh

#include "basics/testcase.hh"

namespace test {

  // ******************************************************** QuadratureTest **

  /** Testing concepts::Quadrature and children of concepts::QuadratureRule
      @author Philipp Frauenfelder, 2003
  */
  class QuadratureTest : public TestCase {
  public:
    virtual ~QuadratureTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests with template parameter 0 (Gauss Lobatto)
    void test0();
    /// Tests with template parameter 1 (Gauss Jacobi Lobatto)
    void test1();
    /// Tests with template parameter 2 (Gauss Jacobi Lobatto)
    void test2();
    /// Tests with template parameter 3 (Gauss Radau Jacobi)
    void test3();
    /// Tests with template parameter 4 (Gauss Jacobi)
    void test4();
    //@}
  };

  // ******************************************************* KarniadakisTest **

  /** Testing concepts::Karniadakis
      @author Philipp Frauenfelder, 2003
  */
  class KarniadakisTest : public TestCase {
  public:
    virtual ~KarniadakisTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests normal shape functions
    void test10();
    /// Tests derivatives of shape functions
    void test11();
    //}@
  };

} // namespace test

#endif // testIntegration_hh
