// element for linear FEM in 3D

#include "element3D.hh"
#include "tetGraphics.hh"
#include "basics/exceptions.hh"
#include "toolbox/elementGraphics.hh"

namespace linearFEM {

  // *********************************************************** Tetrahedron **

  std::auto_ptr<TetrahedronGraphics> Tetrahedron::graphics_(0);

  const concepts::ElementGraphics<Real>* Tetrahedron::graphics() const {
    if (! graphics_.get())
      graphics_.reset(new TetrahedronGraphics());
    return graphics_.get();
  }

  std::ostream& Tetrahedron::info(std::ostream& os) const {
    return os << "Tetrahedron(" << cell_ << ", T = " << *T_ << ')';
  }

} // namespace linearFEM
