// fabric for an optimized solver class for diagonal matrices

#include "diagonalFabric.hh"

namespace concepts {

  // ************************************************** DiagonalSolverFabric **

  template <typename F>
  Operator<F>* DiagonalSolverFabric<F>::operator()(Operator<F>& matrix) {
    Operator<F>* solver = 0;
    const DiagonalMatrix<F>* diagMatrix =
      dynamic_cast<const DiagonalMatrix<F>*>(&matrix);
    conceptsAssert(diagMatrix, concepts::Assertion());
    solver = new DiagonalSolver<F>(*diagMatrix);
    return solver;
  }
  
  template <typename F>
  std::ostream& DiagonalSolverFabric<F>::info(std::ostream& os) const {
    return os << "DiagonalSolverFabric()";
  }
  
} // namespace concepts
