// fabric for an optimized solver class for diagonal matrices

#ifndef diagonalSolverFabric_hh
#define diagonalSolverFabric_hh

#include "diagonal.hh"
#include "solverFabric.hh"

namespace concepts {

  // ************************************************** DiagonalSolverFabric **

  /** Fabric class for \c DiagonalSolver.
      @author Christoph Winkelmann, 2002
  */
  template <typename F>
  class DiagonalSolverFabric : public SolverFabric<F> {
  public:
    /** Creates a diagonal solver with matrix \c
	matrix. You must use a DiagonalMatrix here.
	@param matrix diagonal matrix
    */
    virtual Operator<F>* operator() (Operator<F>& matrix);
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // concepts

#endif // diagonalSolverFabric_hh
