/** @file cgTest.hh
    Testsuite for CG
    @author Philipp Frauenfelder, 2004
*/

#ifndef cgTest_hh
#define cgTest_hh

#include "basics/testcase.hh"
#include "space/space.hh"

using concepts::Real;

namespace concepts {
  template<typename F>
  class Matrix;
  template<typename F>
  class Vector;
}

namespace test {

  /** Test the direct solver CG.
      @author Philipp Frauenfelder, 2004
      @see concepts::CG
  */
  class CgTest : public TestCase {
  public:
    CgTest() : spc(5) {}
    virtual ~CgTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Without preconditioning
    void testNormal(concepts::Matrix<Real>& m, concepts::Vector<Real>& rhs,
		    Real res[5]);
    /// With diagonal preconditioner
    void testPrecond(concepts::Matrix<Real>& m, concepts::Vector<Real>& rhs,
		     Real res[5]);
    //@}
  private:
    concepts::DummySpace<concepts::Real> spc;
  };

} // namespace test

#endif // cgTest_hh
