/** @file pardisoTest.hh
    Testsuite for PARDISO
    @author Philipp Frauenfelder, 2004
*/

#ifndef pardisoTest_hh
#define pardisoTest_hh

#include "basics/testcase.hh"
#include "space/space.hh"

namespace test {

  /** Test the direct solver Pardiso.
      @author Philipp Frauenfelder, 2004
      @see concepts::Pardiso
  */
  class PardisoTest : public TestCase {
  public:
    PardisoTest() : spc(5) {}
    virtual ~PardisoTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests symmetric, positive definite solver
    void testSPD();
    /// Tests unsymmetric solver
    void testUNSYMM();
    //@}
  private:
    concepts::DummySpace<concepts::Real> spc;
  };

} // namespace test

#endif // pardisoTest_hh
