/** @file umfpackTest.hh
    Testsuite for UMFPACK
    @author Philipp Frauenfelder, 2004
*/

#ifndef umfpackTest_hh
#define umfpackTest_hh

#include "basics/testcase.hh"
#include "space/space.hh"

namespace test {

  /** Test the direct solver Umfpack.
      @author Philipp Frauenfelder, 2004
      @see concepts::Umfpack
  */
  class UmfpackTest : public TestCase {
  public:
    UmfpackTest() : spc(5) {}
    virtual ~UmfpackTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests initialization of the solver
    void testinit();
    /// Tests symmetric, positive definite solver
    void testSPD();
    /// Tests unsymmetric solver
    void testUNSYMM();
    //@}
  private:
    concepts::DummySpace<concepts::Real> spc;
  };

} // namespace test

#endif // umfpackTest_hh
