/* testsuite for ElementMatrix from element.hh
 */

#include <iostream>
#include "space/element.hh"

using namespace concepts;

int main(int, char**) {
  ElementMatrix<Real> e(2,2);
  e.zeros();

  std::cout << "e = " << e << std::endl;

  std::cout << e.n() << 'x' << e.m() << std::endl;

  e(1,1) = 1.0;

  std::cout << "e = " << e << std::endl;

  ElementMatrix<Real> f(2,2);
  f.zeros();
  std::cout << "f = " << f << std::endl;
  f = e;
  std::cout << "f = " << f << std::endl;
  f(0,1) = 2.0;
  std::cout << "f = " << f << std::endl;
  f.transpose();
  std::cout << "f = " << f << std::endl;

  f.resize(10,10);
  f.zeros();
  f(5,5) = 8.0;
  std::cout << "f = " << f << std::endl;

  Real g = 1.0;
//    const uint i = 5;
//    g += f(i,i);

  // braucht Real &__restrict blitz::Array<double,2>::operator ()(int, int)
//    g += f(5,5);

  // braucht Real blitz::Array<double,2>::operator ()(int, int) const
//    const ElementMatrix<Real>& h = f;
//    const int i = 5;
//    g += h.operator()(i,i);

  int i = 5;
  g += f(i,i);

  std::cout << "g = " << g << std::endl;

  return 0;
}
