// testing qr factorizations

#ifndef driverTest_hh
#define driverTest_hh

#include "basics/testcase.hh"
#include "operator/sparseMatrix.hh"
#include "sparseqr/driver.hh"

namespace test {

  // ************************************************************ DriverTest **

  /** Tests the integration of the sparseqr package into Concepts.
      @author Philipp Frauenfelder, 2004
  */
  class DriverTest : public TestCase {
  public:
    DriverTest();
    virtual ~DriverTest();
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests Q and its composition with another matrix
    void testQ();
    /// Tests transpose of Q and its composition with another matrix
    void testQt();
    /// Should test QR solver (when it is operational)
    void testSolver();
    //@}
  private:
    concepts::DummySpace<concepts::Real> spc1, spc2;
    concepts::SparseMatrix<concepts::Real> a, b;
    sparseqr::Driver decomp;
    void compare_(const concepts::SparseMatrix<Real>& s,
		  concepts::Operator<Real>& o);
  };

} // namespace test

#endif // driverTest_hh
