/* dynamic array
 */

#include "dynArray.hh"
#include "basics/debug.hh"

// debugging
#define DynArrayBaseDestr_D 0

namespace concepts {

  // ********************************************************** DynArrayBase **

  DynArrayBase::DynArrayBase(const uint htblsz, const uint htblmsk,
			     const uint pgsz, const uint pgmsk,
			     const bool init) :
    init_(init), empty_(true), max_(0), min_(0), npg_(0),
    htblsz_(htblsz), htblmsk_(htblmsk), pgsz_(pgsz), pgmsk_(pgmsk) {
  }

  DynArrayBase::~DynArrayBase() {
    DEBUGL(DynArrayBaseDestr_D, "done.");
  }

  std::ostream& DynArrayBase::info(std::ostream& os) const {
    return os << "DynArrayBase(init = " << init_ << ", emtpy = " << empty_
	      << ", min = " << min_ << ", max = " << max_ << ", npg = "
	      << npg_ << ", htblsz = " << htblsz_ << ", htblmsk = "
	      << htblmsk_ << ", pgsz = " << pgsz_ << ", pgmsk = " << pgmsk_
	      << ")";
  }

} // namespace concepts
