// linear form for vector valued problems

#include "linearForm.hh"
#include "linearFormHelper.hh"

namespace vectorial {

  // ************************************************************ LinearForm **

  template<class F>
  LinearForm<F>::~LinearForm(){
    DEBUGL(LinearFormConstr_D, "deletion done.");
  }

  template<class F>
  void LinearForm<F>::put(concepts::LinearForm<F> &lf,
			  const int i, const int j) {
    //if (vdata_[i]==0 && &lf!=0) ++idx_;
    vdata_[i] = &lf;
    DEBUGL(LinearFormConstr_D,"idx = " << idx_ << ", i = " << i);
  }

  template<class F>
  void LinearForm<F>::operator ()(const concepts::Element<F>& elm,
				  concepts::ElementMatrix<F>& em){
    const Element<F>* ev = dynamic_cast<const Element<F>*>(&elm);
    conceptsAssert(ev, concepts::Assertion());
    LinearFormHelper::assembleComponents(*ev, em, vdata_, vdim_);
  }

  template<class F>
  std::ostream& LinearForm<F>::info(std::ostream& os) const {
    os << "LinearForm(" << idx_ << ", " << vdim_ << ")";
    return os;
  }

  template class LinearForm<Real>;

} // namespace vectorial
